all messages for Guix-related lists mirrored at yhetil.org
 help / color / mirror / code / Atom feed
From: Vincent Legoll <vincent.legoll@gmail.com>
To: 40601@debbugs.gnu.org
Cc: Vincent Legoll <vincent.legoll@gmail.com>
Subject: [bug#40601] [PATCH 16/28] non-interactive mode, usage
Date: Sun, 17 May 2020 19:17:13 +0200	[thread overview]
Message-ID: <20200517171725.732-16-vincent.legoll@gmail.com> (raw)
In-Reply-To: <20200517171725.732-1-vincent.legoll@gmail.com>

---
 etc/guix-install.sh | 68 +++++++++++++++++++++++++++++++++------------
 1 file changed, 51 insertions(+), 17 deletions(-)

diff --git a/etc/guix-install.sh b/etc/guix-install.sh
index 1c22ae95ee..7fb9332e97 100755
--- a/etc/guix-install.sh
+++ b/etc/guix-install.sh
@@ -48,7 +48,6 @@ REQUIRE=(
     "chmod"
     "uname"
     "tail"
-    "realpath"
     "tar"
     "xz"
 )
@@ -454,17 +453,23 @@ sys_make_guix_available()
 
 sys_authorize_build_farms()
 { # authorize the public key of the build farm
-    while true; do
-        read -p "Permit downloading pre-built package binaries from the project's build farm? (yes/no) " yn
-        case $yn in
-            [Yy]*) guix archive --authorize < "${ROOT_HOME}/.config/guix/current/share/guix/ci.guix.gnu.org.pub" &&
-                       _msg "${PAS}Authorized public key for ci.guix.gnu.org";
-                   break;;
-            [Nn]*) _msg "${INF}Skipped authorizing build farm public keys"
-                   break;;
-            *) _msg "Please answer yes or no.";
-        esac
-    done
+    _AUTHORIZE_BUILD_FARM=1
+    if [ "$1" -eq 1 ]; then
+        while true; do
+            read -p "Permit downloading pre-built package binaries from the project's build farm? (yes/no) " yn
+            case "$yn" in
+                [Yy]*) _AUTHORIZE_BUILD_FARM=1; break;;
+                [Nn]*) _AUTHORIZE_BUILD_FARM=0; break;;
+                *) _msg "Please answer yes or no.";;
+            esac
+        done
+    fi
+    if [ "$_AUTHORIZE_BUILD_FARM" -eq 1 ]; then
+        guix archive --authorize < "${ROOT_HOME}/.config/guix/current/share/guix/ci.guix.gnu.org.pub" &&
+            _msg "${PAS}Authorized public key for ci.guix.gnu.org";
+    else
+        _msg "${INF}Skipped authorizing build farm public keys"
+    fi
 }
 
 sys_create_init_profile()
@@ -526,10 +531,41 @@ EOF
     read -r  ANSWER
 }
 
+# Do not change the tabs in the HERE-DOCUMENT
+usage()
+{
+    cat <<-EOF
+	$0: Wrong arguments:
+	$0 [-h|--help] [-n|--non-interactive] [LOCAL_GUIX_BIN_TARBALL]
+
+	-h|--help            Show this help
+	-n|--non-interactive Avoid asing interactive question, run unattended
+	                     automatically allow substitutes from guix build farm
+
+	LOCAL_GUIX_BIN_TARBALL Use the given guix binary tarball file instead of
+	                       downloading latest released one
+EOF
+}
+
+handle_args()
+{
+    _INTERACTIVE=1
+    while [ "$#" -gt 0 ]; do
+        case "$1" in
+            -h|--help) usage; exit 0;;
+            -n|--non-interactive) _INTERACTIVE=0; shift 1;;
+
+            -*) echo "unknown option: $1" >&2; echo; usage; exit 1;;
+            *) TARBALL="$1"; shift 1;;
+        esac
+    done
+}
+
 main()
 {
     local tmp_path
-    welcome
+    handle_args "$@"
+    [ "${_INTERACTIVE}" -eq 1 ] && welcome
 
     _msg "Starting installation ($(date))"
 
@@ -544,19 +580,17 @@ main()
     umask 0022
     tmp_path="$(mktemp -t -d guix.XXXXXX)"
 
-    if [ -z "$1" ]; then
+    if [ -z "${TARBALL}" ]; then
         guix_get_bin_list "${GNU_URL}"
         guix_get_bin "${GNU_URL}" "${BIN_VER}" "${tmp_path}"
         TARBALL="${BIN_VER}.tar.xz"
-    else
-        TARBALL="$(realpath $1)"
     fi
     sys_create_store "${TARBALL}" "${tmp_path}"
     sys_create_build_group
     sys_create_build_user
     sys_enable_guix_daemon
     sys_make_guix_available
-    sys_authorize_build_farms
+    sys_authorize_build_farms "${_INTERACTIVE}"
     sys_create_init_profile
 
     _msg "${INF}cleaning up ${tmp_path}"
-- 
2.26.2





  parent reply	other threads:[~2020-05-17 17:20 UTC|newest]

Thread overview: 77+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2020-04-13 16:04 [bug#40601] [PATCH 0/5] Handle runit-based foreign distributions Vincent Legoll
2020-04-13 16:07 ` [bug#40601] [PATCH 1/5] nix/local.mk: Add missing comment to sysvinit section Vincent Legoll
2020-04-13 16:07   ` [bug#40601] [PATCH 2/5] guix-install.sh: Add xz to requirements Vincent Legoll
2020-04-13 16:07   ` [bug#40601] [PATCH 3/5] guix-install.sh: Fix systemctl not found error message at probe Vincent Legoll
2020-04-13 16:07   ` [bug#40601] [PATCH 4/5] guix-install.sh: Handle local binary tarball file Vincent Legoll
2020-04-13 16:07   ` [bug#40601] [PATCH 5/5] guix-install.sh, guix-binary tarball: Handle runit-based foreign distributions Vincent Legoll
2020-05-17 17:15 ` [bug#40601] [RFC, PATCH 0/28] guix-install.sh: port to other distros & init systems Vincent Legoll
2020-05-17 19:26   ` Julien Lepiller
2020-05-17 19:37     ` Vincent Legoll
2020-05-17 17:16 ` [bug#40601] [PATCH 01/28] nix/local.mk: Add missing comment to sysvinit section Vincent Legoll
2020-05-17 17:16   ` [bug#40601] [PATCH 02/28] guix-install.sh: Add xz to requirements Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 03/28] guix-install.sh: Fix systemctl not found error message at probe Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 04/28] guix-install.sh: Handle local binary tarball file Vincent Legoll
2020-05-23 13:42     ` Tobias Geerinckx-Rice via Guix-patches via
2020-05-23 21:37       ` Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 05/28] guix-install.sh, guix-binary tarball: Handle runit-based foreign distributions Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 06/28] guix-install.sh: trivial whitespace fix Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 07/28] guix-install.sh: Move code in a new function Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 08/28] guix-install.sh: Use getent for both user & group presence checking Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 09/28] guix-install.sh: Fix requirements Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 10/28] guix-install.sh: Replace subshell-inducing command grouping Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 11/28] guix-install.sh: Use a variable for GPG key URL Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 12/28] guix-install.sh: Rework user & group handling, adding busybox support Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 13/28] guix-install.sh: Make grep & mktemp usage compatible with busybox Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 14/28] guix-install.sh: Make tar " Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 15/28] guix-install.sh, guix-binary tarball: Handle openrc-based foreign distributions Vincent Legoll
2020-05-17 17:17   ` Vincent Legoll [this message]
2020-05-17 17:17   ` [bug#40601] [PATCH 17/28] fix variable quoting in sys_make_guix_available Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 18/28] Replace the use of "which" by "command -v" Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 19/28] Remove &> and >& bashisms Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 20/28] Add missing variable quoting & curly-bracketing for dl_path Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 21/28] Remove unused variable Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 22/28] Remove local bashisms Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 23/28] Remove $UID bashism Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 24/28] Remove some "[[" bashisms Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 25/28] Remove unused variable set by "read" Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 26/28] Add _debug_func() helper function Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 27/28] Fix variable use in guix_get_bin_list() Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 28/28] Remove "[[" bashisms in chk_init_sys() Vincent Legoll
2020-05-23 12:36   ` [bug#40601] [PATCH 01/28] nix/local.mk: Add missing comment to sysvinit section Tobias Geerinckx-Rice via Guix-patches via
2020-05-22 13:44 ` [bug#40601] [guix-daemon now working on parabola with openrc] jgart--- via Guix-patches via
2020-05-22 18:40   ` Leo Famulari
2020-05-31 20:41 ` [bug#40601] New reduced patchset, the easy bits first Vincent Legoll
2020-12-18 12:28   ` Christopher Baines
2020-12-18 19:35     ` Vincent Legoll
2020-12-20 17:30       ` Vincent Legoll
2020-05-31 20:42 ` [bug#40601] [PATCH 1/7] guix-install.sh: Remove "[[" bashisms in chk_init_sys() Vincent Legoll
2020-05-31 20:42   ` [bug#40601] [PATCH 2/7] guix-install.sh: Remove $UID bashism Vincent Legoll
2020-05-31 20:42   ` [bug#40601] [PATCH 3/7] guix-install.sh: Fix requirements Vincent Legoll
2020-05-31 20:42   ` [bug#40601] [PATCH 4/7] guix-install.sh: trivial whitespace fix Vincent Legoll
2020-05-31 20:42   ` [bug#40601] [PATCH 5/7] guix-install.sh: Add variable quoting in sys_make_guix_available Vincent Legoll
2020-05-31 20:42   ` [bug#40601] [PATCH 6/7] guix-install.sh: Fix variable uses in guix_get_bin_list() Vincent Legoll
2020-05-31 20:42   ` [bug#40601] [PATCH 7/7] guix-install.sh: Add missing variable quoting & curly-bracketing in guix_get_bin() Vincent Legoll
2020-12-18 11:37     ` Christopher Baines
2020-10-07 16:09 ` [bug#40601] [PATCH 0/5] Handle runit-based foreign distributions zimoun
2020-12-20 17:28 ` [bug#40601] [PATCH 1/5] guix-install.sh: Remove "[[" bashisms in chk_init_sys() Vincent Legoll
2020-12-20 17:28   ` [bug#40601] [PATCH 2/5] guix-install.sh: Remove $UID bashism Vincent Legoll
2020-12-23 12:17     ` Christopher Baines
2020-12-23 14:59       ` Vincent Legoll
2020-12-20 17:28   ` [bug#40601] [PATCH 3/5] guix-install.sh: Fix requirements Vincent Legoll
2020-12-20 17:28   ` [bug#40601] [PATCH 4/5] guix-install.sh: Fix detection of SysV init system Vincent Legoll
2020-12-20 17:28   ` [bug#40601] [PATCH 5/5] guix-install.sh: Check daemonize package presence for sysv-init Vincent Legoll
2021-09-02 17:51 ` [bug#40601] guix-daemon runit service on void jgart via Guix-patches via
  -- strict thread matches above, loose matches on Subject: below --
2020-01-07 21:29 bug#39023: binary installation manual doesn't work on Alpine Linux symphonia
2020-01-08 12:34 ` Gábor Boskovits
2020-01-22  3:53   ` Tobias Geerinckx-Rice via Bug reports for GNU Guix
2020-01-22 19:42     ` Gábor Boskovits
2020-01-22 19:58       ` Tobias Geerinckx-Rice via Bug reports for GNU Guix
2020-01-22 20:03         ` Gábor Boskovits
2020-02-19 15:56           ` zimoun
2020-01-22  1:44 ` bug#39023: adduser/addgroup vs useradd/groupadd zimoun
2020-01-22  4:03   ` Tobias Geerinckx-Rice via Bug reports for GNU Guix
2020-01-22  8:31     ` zimoun
2020-04-23 11:55 ` bug#39023: binary installation manual doesn't work on Alpine Linux Vincent Legoll
2020-04-23 11:55   ` [bug#40601] " Vincent Legoll
2020-04-23 13:29   ` zimoun
2020-04-23 14:15     ` Vincent Legoll

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20200517171725.732-16-vincent.legoll@gmail.com \
    --to=vincent.legoll@gmail.com \
    --cc=40601@debbugs.gnu.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this external index

	https://git.savannah.gnu.org/cgit/guix.git

This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.